size(10cm);

path[] nomiddle(path p) {
  return subpath(p,0,1/3)^^subpath(p,2/3,1);
}

path[] house = shift((-1/2,-3/4))*(unitsquare//^^I--(1/2,3/2)--(I+1)
^^shift(1/2,3/2)*scale(1.3/sqrt(2))*((0,0)--expi(-pi/4)^^(0,0)--expi(5pi/4))
^^shift(1/4)*scale(1/3,1/2)*unitsquare);

pair a = (0,0);
pair b = (1,0);
pair c = I-0.2;
pair d = 1.2 + I;
pair e = (0.2,1.7);
pair f = 2I + 1;
pair[] places = {a,b,c,d,e,f};
pair[] safe  = {NE,SE,NE,NE,NE,NE};


path[] g1 = 
    a--b
  ^^a--c
  ^^a{NW}..c
  ^^b{WNW}..{WNW}c
  ^^b--d
  ^^b{NE}..d
  ^^b{NW}..d
  ^^c--d
  ^^c--e
  ^^c{N}..{SE}f
  ^^d{NNW}..{NNW}e
  ^^d--f
  ^^e--f
  ^^e{SE}..f;
draw(g1);
for(int i=0;i<places.length;++i) {
  //dot(places[i]);
  filldraw(shift(places[i])*scale(0.07)*unitcircle,white);
  draw(shift(places[i]/*+0.05safe[i]*/)*scale(0.05)*house);
}
