size(0,550);

import flowchart;

block block1=rectangle(Label("Example",magenta),
		       pack(Label("Start:",heavygreen),"",Label("$A:=0$",blue),
			    "$B:=1$"),(-0.5,3),palegreen,paleblue,red);
block block2=diamond(Label("Choice?",blue),(0,2),palegreen,red);
block block3=roundrectangle("Do something",(-1,1));
block block4=bevel("Don't do something",(1,1));
block block5=circle("End",(0,0));

block start=circle("Start",(0,7));

block compare=rectangle(pack(Label("Compare numbers"),Label("with your partner")),(0,6));

block check=diamond(pack(Label("Which number"),Label(" is bigger?")),(0,5));

block stay=rectangle(pack(Label("Stay where"),Label("you are")),(-2,4));
block switch=rectangle(pack(Label("Change places"),Label("with your partner")),(2,4));

block wherePartner=diamond(pack(Label("Where is"),Label("your partner?")),(0,3));

block sbRight=diamond(pack(Label("Is there someone"),Label("to your right?")),(-2,2));
block sbLeft=diamond(pack(Label("Is there someone"),Label("to your left?")),(2,2));

block wait=rectangle(pack(Label("Wait for"),Label("a partner")),(0,1));

block newPartner=rectangle(pack(Label("They are your"),Label("new partner")),(0,0));

draw(start);

draw(compare);

draw(check);

draw(stay);
draw(switch);

draw(wherePartner);
draw(sbRight);
draw(sbLeft);

draw(wait);
draw(newPartner);
//draw(block1);
//draw(block2);
//draw(block3);
//draw(block4);
//draw(block5);

add(new void(picture pic, transform t) {
    blockconnector operator --=blockconnector(pic,t);
    start--Down--Arrow--compare;
    compare--Down--Arrow--check;
    check--Label("right",0.5,NE)--Right--Down--Arrow--switch;
    check--Label("left",0.5,NW)--Left--Down--Arrow--stay;
    stay--Right--Down--Arrow--wherePartner;
    switch--Left--Down--Arrow--wherePartner;
    wherePartner--Label("to the right",0.1,NE)--Right--Down--Arrow--sbLeft;
    wherePartner--Label("to the left",0.2,NW)--Left--Down--Arrow--sbRight;
    sbRight--Label("no",0.3,N)--Right--Down--Arrow--wait;
    sbLeft--Label("no",0.3,N)--Left--Down--Arrow--wait;
    sbRight--Label("yes",0.3,E)--Down--Right--Arrow--newPartner;
    sbLeft--Label("yes",0.3,W)--Down--Left--Arrow--newPartner;
    //wait--Down--Right--Up--Left--Arrow--wait;
    draw(pic,wait.bottom(t){S}..{W}wait.right(t),Arrow);

    newPartner--Down--Down--Down
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Left
    --Up--Right--Arrow--compare;
    //draw(pic,newPartner.bottom(t)--(0,-1)--(-4,-1)--(-4,9)--compare.left(t),Arrow);

    //block1--Right--Down--Arrow--block2;
    //block2--Label("Yes",0.5,NW)--Left--Down--Arrow--block3;
    //block2--Right--Label("No",0.5,NE)--Down--Arrow--block4;
    //block4--Down--Left--Arrow--block5;
    //block3--Down--Right--Arrow--block5;
  });
